﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Configuration;

namespace CodePlex.TfsPluginSuite.Configuration
{
    [ConfigurationCollection(typeof(ForbiddenPatternConfigurationElement), AddItemName = "ForbiddenPattern", CollectionType = ConfigurationElementCollectionType.BasicMap)]
    public class ForbiddenPatternConfigurationElementCollection : ConfigurationElementCollection
    {
        protected override ConfigurationElement CreateNewElement()
        {
            return new ForbiddenPatternConfigurationElement();
        }

        protected override object GetElementKey(ConfigurationElement element)
        {
            if (element == null)
                throw new ArgumentNullException("element");

            return ((ForbiddenPatternConfigurationElement)element).Name;
        }

        [ConfigurationProperty("enabled", IsRequired = true)]
        public bool Enabled
        {
            get
            {
                return (bool)base["enabled"];
            }
        }
    }

    public class ForbiddenPatternConfigurationElement : ConfigurationElement
    {
        [ConfigurationProperty("name", IsRequired = true, IsKey = true)]
        public string Name
        {
            get
            {
                return (string)base["name"];
            }
        }

        [ConfigurationProperty("regularExpression", IsRequired = true, IsKey = true)]
        public string RegularExpression
        {
            get
            {
                return (string)base["regularExpression"];
            }
        }

        [ConfigurationProperty("message", IsRequired = true, IsKey = true)]
        public string Message
        {
            get
            {
                return (string)base["message"];
            }
        }
    }
}
