﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Reflection;
using System.Configuration;

namespace CodePlex.TfsPluginSuite.Configuration
{
    //TODO: Should this class be static?
    public static class TfsPluginSuiteConfigurationManager
    {
        private static Assembly configurationDefiningAssembly;

        static TfsPluginSuiteConfigurationManager()
        {
            AppDomain.CurrentDomain.AssemblyResolve += ConfigResolveEventHandler;
            string strPluginFile = new Uri(Assembly.GetExecutingAssembly().CodeBase).LocalPath;
            configurationDefiningAssembly = Assembly.LoadFrom(strPluginFile);
            var exeFileMap = new ExeConfigurationFileMap();
            exeFileMap.ExeConfigFilename = string.Format("{0}.config", strPluginFile);
            var customConfig = ConfigurationManager.OpenMappedExeConfiguration(exeFileMap, ConfigurationUserLevel.None);
            Section = customConfig.GetSection("TfsPluginSuite") as TfsPluginSuiteConfigurationSection;
            AppDomain.CurrentDomain.AssemblyResolve -= ConfigResolveEventHandler;
        }

        public static TfsPluginSuiteConfigurationSection Section { get; private set; }

        private static Assembly ConfigResolveEventHandler(object sender, ResolveEventArgs args)
        {
            return configurationDefiningAssembly;
        }
    }
}
