﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Configuration;

namespace CodePlex.TfsPluginSuite.Configuration
{
    [ConfigurationCollection(typeof(ForbiddenPatternConfigurationElement), AddItemName = "ForbiddenPattern", CollectionType = ConfigurationElementCollectionType.BasicMap)]
    public class ForbiddenPatternConfigurationElementCollection : ConfigurationElementCollection
    {
        protected override ConfigurationElement CreateNewElement()
        {
            return new ForbiddenPatternConfigurationElement();
        }

        protected override object GetElementKey(ConfigurationElement element)
        {
            if (element == null)
            {
                throw new ArgumentNullException("element");
            }

            return ((ForbiddenPatternConfigurationElement)element).Name;
        }

        [ConfigurationProperty("enabled", DefaultValue=(bool)false)]
        public bool Enabled
        {
            get
            {
                return (bool)base["enabled"];
            }
        }
    }
}
