﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Configuration;

namespace CodePlex.TfsPluginSuite.Configuration
{
    [ConfigurationCollection(typeof(DenyWorkItemsConfigurationElement), AddItemName = "DenyWorkItems", CollectionType = ConfigurationElementCollectionType.BasicMap)]
    public class DeniedWorkItemsPolicyConfigurationElementCollection : ConfigurationElementCollection
    {
        protected override ConfigurationElement CreateNewElement()
        {
            return new DenyWorkItemsConfigurationElement();
        }

        protected override object GetElementKey(ConfigurationElement element)
        {
            if (element == null)
            {
                throw new ArgumentNullException("element");
            }

            return ((DenyWorkItemsConfigurationElement)element).Name;
        }

        [ConfigurationProperty("enabled", DefaultValue=(bool)false)]
        public bool Enabled
        {
            get
            {
                return (bool)base["enabled"];
            }
        }
    }
}
